  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


:CHECKHELP
		echo.%*|find /i "/?">nul:
		if %errorlevel% equ 0 goto :HELP
		echo.%*|find /i "/h">nul:
		if %errorlevel% equ 0 goto :HELP
		echo.%*|find /i "/help">nul:
		if %errorlevel% equ 0 goto :HELP
goto :SETUP %*


:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG
	set BAT_ECHO=call :ECHOONLY


	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:

	set bat_logfile=!bat_exedir!\Zipdir_7za.bat.log
	
	set bat_submissiondir=%~1
	set bat_submissionbasedir=%~dp1::
	set bat_submissionbasedir=!bat_submissionbasedir:\::=!
	set bat_submissionbasedir=!bat_submissionbasedir:::=!
	
	set bat_targetzipfilename=%~nx1.zip
	set bat_targetfullzipfile=!bat_submissionbasedir!\!bat_targetzipfilename!
goto :MAIN %*
	

:MAIN
echo goto :MAIN %*
set bat_
		rem The errorlevel will be "0" if there are any directories under
		rem CapturedFiles. 
	!bat_echolog! '    dir "!bat_submissiondir!\CapturedFiles" /s/b /ad
	dir "!bat_submissiondir!" /s/b /ad
	rem if !errorlevel! equ 0 (
	if exist "!bat_submissiondir!" (
		set bat_sourcecaptureddir=!bat_submissiondir!\!bat_camera!\CapturedFiles
		echo.
		dir "!bat_sourcecaptureddir!" /s/b /ad /on
		echo.
		set /p bat_choice="Do you want to delete all the *.bin files from [!bat_sourcecaptureddir!]? [Y/N]"
		echo.
		if /i "!bat_choice!" equ "y" (
			!bat_echolog! '    rd /s /q "!bat_sourcecaptureddir!"
			                   rd /s /q "!bat_sourcecaptureddir!"
		)
		

		echo '    call "!bat_exedir!\7za.exe" a -tzip "!bat_targetfullzipfile!" "!bat_submissiondir!"
		          call "!bat_exedir!\7za.exe" a -tzip "!bat_targetfullzipfile!" "!bat_submissiondir!"

		set bat_returncode=!errorlevel!
		if /i "!bat_returncode!" neq "0" (
			echo '    ERROR - Zip failed.
			goto :DONE
		)

		echo dir "!bat_targetfullzipfile!" /b /a-d
		     dir "!bat_targetfullzipfile!" /b /a-d
		if not exist "!bat_targetfullzipfile!" (
			echo '    ERROR - Zip failed to produce the output files
		)

				echo move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"
				     move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"

if true equ false (
		echo '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionbasedir!\!bat_targetzipfilename!" /s/b /a-d`^) do ...
		for           /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionbasedir!\!bat_targetzipfilename!" /s/b /a-d`) do (
			set bat_tempfull=!bat_submissionbasedir!\%%a
			set bat_dirname=%%~dpa::
			set bat_dirname=!bat_dirname:\::=!
			set bat_dirname=!bat_dirname:::=!
			set bat_zipsize=%%~za
			
			echo bat_tempfull=!bat_tempfull!
			echo bat_dirname=!bat_dirname!
			echo bat_zipsize=!bat_zipsize!
			
			if /i !bat_zipsize! GTR 100 (
				echo move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"
				     move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"
			)
		)
)
	) else (
		echo xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		echo xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		echo Skipped "!bat_submissiondir!>>"!bat_logfile!"
		echo Skipped "!bat_submissiondir!
	)


goto :DONE %*






:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








:HELP
	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]
	echo.
	echo Usage %~nx0 fullsourcedir
	echo.
	echo Example:
	echo   The following command will zip each directory for the month of
	echo   August, 2011 that exist under the SubmissionFiles directory...
	echo.
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "e:\cams\SubmissionFiles
	echo     \2011_08_??" /ad /b /on`^) do ^(call ^"c:\cams\zipdir_7za.bat^"  
	echo     ^"e:\cams\SubmissionFiles\%%a^"^)
	echo.
	echo   This will zip each dir that matches the filespec, "2011_08_??". It will 
	echo   rename the source directory to "source_zipped" if the zip is successful.  
	echo   Example: After running this for "2011_08_20", you will end up with the 
	echo            following:
	echo               2011_08_20_zipped    ^(Dir^)
	echo               2011_08_20.zip
	echo            
	echo.
	echo   It will not delete the original "2011_08_20" directory.  You will 
	echo   need to do that on your own.
	echo.
	echo   The compression ratio seems to be about 35%-40%
	echo.
	echo Note: This uses the Seven-Zip commandline utility ^(7za.exe^)
	echo.

	
:DONE
